#include "ap.h"


// Optimized fnt using table lookup for the powers of W

// void tablefnt (modint data[], modint wtable[], size_t ptable[], size_t nn, int s=1);
// void itablefnt (modint data[], modint wtable[], size_t ptable[], size_t nn, int s=1);

asm ("
    .globl tablefnt
    .globl itablefnt

.align 32
tablefnt:
    subl $32, %esp
    pushl %ebx
    pushl %ecx
    pushl %edx
    pushl %esi
    pushl %edi
    pushl %ebp

    movl 60(%esp), %eax
    movl 72(%esp), %ebx
    shll $2, %ebx
    addl %ebx, %eax
    movl %ebx, 44(%esp)
    movl %eax, 52(%esp)
    movl $4, 32(%esp)

    movl modulus, %ecx

    fldl imodulus
    flds chopper64
    fxch %st(1)
    fildl modulus
    fxch %st(1)

    tablefntloop:
    movl 44(%esp), %eax
    shrl $1, %eax
    cmpl $4, %eax
    jb tablefntend
    movl %eax, 44(%esp)
    movl %eax, %ebx
    addl 60(%esp), %eax
    addl %ebx, %ebx
    movl %eax, 48(%esp)
    movl %ebx, 40(%esp)


    movl 60(%esp), %esi

    tablefntfor1:
    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi
    movl 52(%esp), %eax

    cmpl %eax, %esi
    jae tablefntfor1end

    movl (%esi), %eax
    movl (%edi), %ebx

    addl %eax, %ebx
    addl %eax, %eax
    subl %ebx, %eax
    sbbl %edx, %edx
    subl %ecx, %ebx
    sbbl %ebp, %ebp
    andl %ecx, %edx
    andl %ecx, %ebp
    addl %edx, %eax
    addl %ebp, %ebx

    movl %eax, (%edi)
    movl %ebx, (%esi)

    movl 40(%esp), %eax
    addl %eax, %esi
    jmp tablefntfor1

    tablefntfor1end:


    movl 64(%esp), %ebp
    movl 32(%esp), %eax
    addl %eax, %ebp
    movl %ebp, 28(%esp)

    movl 60(%esp), %eax
    addl $4, %eax

    tablefntfor2:
    cmpl 48(%esp), %eax
    jae tablefntfor2end

    movl %eax, 36(%esp)
    movl %eax, %esi

    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi
    movl 52(%esp), %eax

    cmpl %eax, %esi
    jae tablefntfor3

    movl (%esi), %eax
    movl (%edi), %ebx

    addl %eax, %ebx
    addl %eax, %eax
    subl %ebx, %eax
    sbbl %edx, %edx
    subl %ecx, %ebx
    sbbl %ebp, %ebp
    andl %ecx, %edx
    andl %ecx, %ebp
    addl %edx, %eax
    addl %ebp, %ebx

    movl %eax, 24(%esp)
    movl %ebx, (%esi)

    movl 40(%esp), %eax
    movl 28(%esp), %ebp
    addl %eax, %esi

    tablefntfor3:

    fildl 24(%esp)
    fildl (%ebp)

    movl 52(%esp), %eax

    cmpl %eax, %esi
    jae tablefntfor3end

    fmulp %st, %st(1)

    movl %esi, %edx
    movl 44(%esp), %ebx
    addl %ebx, %edx

    fld %st
    fmul %st(2), %st

    pushl %edx

    movl (%esi), %eax
    movl (%edx), %ebx

    fadd %st(4), %st

    addl %eax, %ebx
    addl %eax, %eax
    subl %ebx, %eax

    fsub %st(4), %st

    sbbl %edx, %edx
    subl %ecx, %ebx
    sbbl %ebp, %ebp
    andl %ecx, %edx

    fmul %st(3), %st

    andl %ecx, %ebp
    addl %edx, %eax
    addl %ebp, %ebx
    movl 32(%esp), %ebp

    fsubrp %st, %st(1)

    movl %eax, 28(%esp)
    movl 44(%esp), %eax
    movl %ebx, (%esi)
    addl %eax, %esi

    fistpl (%edi)

    popl %edi
    jmp tablefntfor3

    tablefntfor3end:

    fmulp %st, %st(1)
    fld %st
    fmul %st(2), %st
    fadd %st(4), %st
    fsub %st(4), %st
    fmul %st(3), %st

    movl 28(%esp), %ebp
    movl 32(%esp), %eax

    fsubrp %st, %st(1)

    addl %eax, %ebp
    movl %ebp, 28(%esp)
    movl 36(%esp), %eax
    addl $4, %eax

    fistpl (%edi)

    jmp tablefntfor2

    tablefntfor2end:


    shll $1, 32(%esp)
    jmp tablefntloop


    tablefntend:

    cmpl $0, 76(%esp)
    je tablefntnos

    movl 68(%esp), %ebp
    movl 60(%esp), %ebx

    tablefntscramble:
    movl (%ebp), %esi
    movl 4(%ebp), %edi
    cmpl %esi, %edi
    je tablefntnos
    movl (%ebx, %esi, 4), %eax
    movl (%ebx, %edi, 4), %edx
    addl $8, %ebp
    movl %eax, (%ebx, %edi, 4)
    movl %edx, (%ebx, %esi, 4)
    jmp tablefntscramble

    tablefntnos:

    fstp %st
    fstp %st
    fstp %st

    popl %ebp
    popl %edi
    popl %esi
    popl %edx
    popl %ecx
    popl %ebx
    addl $32, %esp

    ret

.align 32
itablefnt:
    subl $32, %esp
    pushl %ebx
    pushl %ecx
    pushl %edx
    pushl %esi
    pushl %edi
    pushl %ebp

    cmpl $0, 76(%esp)
    je itablefntnos

    movl 68(%esp), %ebp
    movl 60(%esp), %ebx

    itablefntscramble:
    movl (%ebp), %esi
    movl 4(%ebp), %edi
    cmpl %esi, %edi
    je itablefntnos
    movl (%ebx, %esi, 4), %eax
    movl (%ebx, %edi, 4), %edx
    addl $8, %ebp
    movl %eax, (%ebx, %edi, 4)
    movl %edx, (%ebx, %esi, 4)
    jmp itablefntscramble

    itablefntnos:


    movl 60(%esp), %eax
    movl 72(%esp), %ebx
    shll $2, %ebx
    addl %ebx, %eax
    movl %ebx, 32(%esp)
    movl %eax, 52(%esp)
    movl $4, 44(%esp)

    movl modulus, %ecx

    fldl imodulus
    flds chopper64
    fxch %st(1)
    fildl modulus
    fxch %st(1)

    itablefntloop:
    movl 32(%esp), %eax
    shrl $1, %eax
    cmpl $4, %eax
    jb itablefntend
    movl %eax, 32(%esp)
    movl 44(%esp), %eax
    movl %eax, %ebx
    addl 60(%esp), %eax
    movl %eax, 48(%esp)
    addl %ebx, %ebx
    movl %ebx, 40(%esp)


    movl 60(%esp), %esi

    itablefntfor1:
    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi
    movl 52(%esp), %eax

    cmpl %eax, %esi
    jae itablefntfor1end

    movl (%esi), %eax
    movl (%edi), %ebx

    addl %eax, %ebx
    addl %eax, %eax
    subl %ebx, %eax
    sbbl %edx, %edx
    subl %ecx, %ebx
    sbbl %ebp, %ebp
    andl %ecx, %edx
    andl %ecx, %ebp
    addl %edx, %eax
    addl %ebp, %ebx

    movl %eax, (%edi)
    movl %ebx, (%esi)

    movl 40(%esp), %eax
    addl %eax, %esi
    jmp itablefntfor1

    itablefntfor1end:


    movl 64(%esp), %ebp
    movl 32(%esp), %eax
    addl %eax, %ebp
    movl %ebp, 28(%esp)

    movl 60(%esp), %eax
    addl $4, %eax

    itablefntfor2:
    cmpl 48(%esp), %eax
    jae itablefntfor2end

    movl %eax, 36(%esp)
    movl %eax, %esi

    movl 28(%esp), %ebp
    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi

    fildl (%ebp)
    fildl (%edi)
    fmulp %st, %st(1)
    fld %st
    fmul %st(2), %st
    fadd %st(4), %st
    fsub %st(4), %st
    fmul %st(3), %st
    fsubrp %st, %st(1)

    movl 40(%esp), %ebx
    movl %edi, %edx
    addl %ebx, %edx
    movl 28(%esp), %ebp

    fistpl 24(%esp)

    itablefntfor3:

    fildl (%ebp)
    fildl (%edx)

    movl 52(%esp), %ebx
    movl 40(%esp), %eax
    subl %eax, %ebx

    cmpl %ebx, %esi
    jae itablefntfor3end

    fmulp %st, %st(1)

    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi

    fld %st
    fmul %st(2), %st

    movl (%esi), %eax
    movl 24(%esp), %ebx
    addl %eax, %ebx
    addl %eax, %eax

    fadd %st(4), %st

    subl %ebx, %eax
    sbbl %edx, %edx
    subl %ecx, %ebx

    fsub %st(4), %st

    sbbl %ebp, %ebp
    andl %ecx, %edx
    andl %ecx, %ebp
    addl %edx, %eax

    fmul %st(3), %st

    addl %ebp, %ebx
    movl %eax, (%edi)
    movl %ebx, (%esi)
    movl 40(%esp), %eax

    fsubrp %st, %st(1)

    addl %eax, %esi
    movl %edi, %edx
    addl %eax, %eax
    addl %eax, %edx
    movl 28(%esp), %ebp

    fistpl 24(%esp)

    jmp itablefntfor3

    itablefntfor3end:

    fstp %st
    fstp %st

    movl %esi, %edi
    movl 44(%esp), %ebx
    addl %ebx, %edi

    movl (%esi), %eax
    movl 24(%esp), %ebx

    addl %eax, %ebx
    addl %eax, %eax
    subl %ebx, %eax
    sbbl %edx, %edx
    subl %ecx, %ebx
    sbbl %ebp, %ebp
    andl %ecx, %edx
    andl %ecx, %ebp
    addl %edx, %eax
    addl %ebp, %ebx

    movl %eax, (%edi)
    movl %ebx, (%esi)

    movl 28(%esp), %ebp
    movl 32(%esp), %eax
    addl %eax, %ebp
    movl %ebp, 28(%esp)

    movl 36(%esp), %eax
    addl $4, %eax
    jmp itablefntfor2

    itablefntfor2end:


    shll $1, 44(%esp)
    jmp itablefntloop


    itablefntend:

    fstp %st
    fstp %st
    fstp %st

    popl %ebp
    popl %edi
    popl %esi
    popl %edx
    popl %ecx
    popl %ebx
    addl $32, %esp

    ret
");
